package com.ycwl.basic.controller.mobile;

import com.ycwl.basic.model.pc.order.req.OrderAddOrUpdateReq;
import com.ycwl.basic.model.pc.order.req.OrderReqQuery;
import com.ycwl.basic.service.pc.OrderService;
import com.ycwl.basic.utils.ApiResponse;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @Author：longbinbin
 * @Date：2024/12/4 17:16
 */
@RestController
@RequestMapping("/api/mobile/order/v1")
@Api(tags = "订单相关接口")
public class AppOrderController {

    @Autowired
    private OrderService orderService;

    @ApiOperation("用户端订单列表查询")
    @PostMapping("/page")
    public ApiResponse pageQuery(@RequestBody OrderReqQuery orderReqQuery) {
        //TODO 添加用户openid查询条件,仅查询当前用户自己的订单
        return orderService.pageQuery(orderReqQuery);
    }
    @ApiOperation("用户端订单详情查询")
    @GetMapping("getOrderDetails/{id}")
    public ApiResponse getOrderDetails(@PathVariable("id") Long id) {
        return orderService.detail(id);
    }

    @ApiOperation("用户端订单新增")
    @PostMapping("/addOrder")
    public ApiResponse addOrder(@RequestBody OrderAddOrUpdateReq orderAddReq) {
        orderService.add(orderAddReq);
        return ApiResponse.success("");
    }

    @ApiOperation("/支付接口")
    @PostMapping("/buy")
    public ApiResponse buy(@RequestBody Object buyData) {
        //TODO 处理购买逻辑
        return ApiResponse.success("");
    }
}
